import { feature } from 'topojson';
import { dsv, json } from 'd3';


export const loadAndProcessData = () => 
  Promise
    .all([
      dsv(';', 'https://vizhub.com/vladvaculin/datasets/un-population-estimates-medium-2019.csv'),
      json('https://unpkg.com/visionscarto-world-atlas@0.0.6/world/50m.json')
    ])
    .then(([unData, topoJSONdata]) => {

       const rowById = unData.reduce((accumulator, d) => {
        accumulator[d['Country code']] = d;
        return accumulator;
      }, {});

      const countries = feature(topoJSONdata, topoJSONdata.objects.countries);

      countries.features.forEach(d => {
        Object.assign(d.properties, rowById[+d.id]);
      });
			const featuresWithPopulation = countries.features
      	.filter(d => d.properties['2020'])
      	.map(d => {
          d.properties['2020'] = +d.properties['2020'].replace(/ /g, '') * 1000;
        	return d;
        });
      
      return {
        features: countries.features,
        featuresWithPopulation};
    });